package cn.estsh.i3plus.core.apiservice.controller.busi;

import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.base.enumutil.ImppEnumUtil;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.Arrays;

/**
 * @Description :
 * @Reference :
 * @Author : wei.peng
 * @Date : 2018-10-22 15:58
 * @Modify :
 **/
@RestController
@RequestMapping("/enum")
@Api(description = "系统枚举服务")
public class EnumController {

    @GetMapping("/find/method-level")
    @ApiOperation(value = "功能类型", notes = "查询全部功能类型功能")
    public ResultBean getByEnumMethodLevel(){
         return new ResultBean(true, "操作成功",
                 Arrays.asList(CommonEnumUtil.METHOD_LEVEL.values()));
    }

    @GetMapping("/find/status")
    @ApiOperation(value = "功能状态", notes = "查询全部功能状态功能")
    public ResultBean getByStatus(){
        return new ResultBean(true, "操作成功",
                Arrays.asList(CommonEnumUtil.STATUS.values()));
    }

    @GetMapping("/find/organize-type")
    @ApiOperation(value = "组织类型", notes = "查询全部组织类型功能")
    public ResultBean getByOrganizeType(){
        return new ResultBean(true, "操作成功",
                Arrays.asList(ImppEnumUtil.ORGANIZE_YTPE.values()));
    }


}
