package cn.estsh.i3plus.core.apiservice.serviceimpl.busi;

import cn.estsh.i3plus.core.api.iservice.busi.ISysMenuService;
import cn.estsh.i3plus.core.apiservice.dao.ISysMenuDao;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.impp.framework.boot.util.ResultBean;
import cn.estsh.i3plus.pojo.platform.bean.SysMenu;
import cn.estsh.i3plus.pojo.platform.bean.SysUser;
import cn.estsh.i3plus.pojo.platform.repository.SysMenuRepository;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Optional;

/**
 * @Description : 系统功能业务接口实现 
 * @Reference   :
 * @Author      : wei.peng
 * @Date        : 2018-10-22 15:18:14.969
 * @Modify      :
 **/
@Service
public class SysMenuServiceImpl implements ISysMenuService {

    public static final Logger LOGGER = LoggerFactory.getLogger(SysMenuServiceImpl.class);

    @Autowired
    private SysMenuRepository sysMenuRepository;

    @Autowired
    private ISysMenuDao iSysMenuDao;

    @Override
    public void updateSysMenu(SysMenu sysMenu) {
        LOGGER.info("系统功能 SYS_MENU :{}", sysMenu);
        if(sysMenu != null){
            sysMenuRepository.update(sysMenu);
           // return new ResultBean(true,"操作成功",sysMenu);
        }
        //return new ResultBean(false,"操作失败");
    }

    @Override
    public void updateSysMenuStatus(long id, int status, String modifyUser) {
        LOGGER.info("系统功能 SYS_MENU  id:{} status:{} modifyUser:{}", id,status,modifyUser);
        SysMenu menu = sysMenuRepository.getById(id);
        if(null != menu){
            menu.setMenuStatus(status);
            menu.setModifyUser(modifyUser);
            sysMenuRepository.update(menu);
            //TODO 统一修改
//            String modifyDatetime = "";
//            sysMenuRepository.updateByProperties(
//                    new String[]{"id"},
//                    new Object[]{id},
//                    new String[]{"menuStatus","modifyUser","modifyDatetime"},
//                    new Object[]{status,modifyUser,modifyDatetime}
//            );
//            return new ResultBean(true,"操作成功");
            //return new ResultBean(true,"操作成功");
        }
       // return new ResultBean();
    }

    @Override
    public void deleteSysMenuById(long id,String modifyUser) {
        LOGGER.info("系统功能 SYS_MENU Key:{}", id);
        //TODO 记录平台用户操作日志
        long count = iSysMenuDao.queryCountByParentId(id);
        if(count >= 1){
            //return new ResultBean(false,"操作失败","该数据有引用关系，请先删除引用关系");
        }
        sysMenuRepository.deleteById(id);
        //return new ResultBean(true,"操作成功");
    }

    @Override
    public void insertSysMenu(SysMenu sysMenu) {
        LOGGER.info("系统功能 SYS_MENU :{}", sysMenu);
        if(null != sysMenu.getMenuTypeId()){
            sysMenu.setRedMenuTypeName(CommonEnumUtil.METHOD_LEVEL.valueOf(sysMenu.getMenuTypeId()));
        }
        /*if(0 != sysMenu.getParentId()){
            SysMenu parent = sysMenuRepository.getById(sysMenu.getParentId());
            if(null != parent){
                sysMenu.setRedParentName(parent.getName());
            }

        }*/
        SysMenu insert = sysMenuRepository.insert(sysMenu);
        //return new ResultBean(true,"操作成功",insert);
    }

    @Override
    public List<SysMenu> findSysMenuAll() {
        LOGGER.info("系统功能 SYS_MENU find All");
        return sysMenuRepository.findAll();
    }

    @Override
    public SysMenu getSysMenuById(long id) {
        LOGGER.info("系统功能 SYS_MENU find id:{}", id);
        return sysMenuRepository.getOne(id);
    }
}
